Attribute VB_Name = "WhatToDoWithFiles"
Option Explicit

Global glCompare_Files$
Global glCompareFiles_Source$
Global glCompareFiles_Target$
Global glCompareFiles_SourceParent$
Global glCompareFiles_TargetParent$


Global CheckSpacesInName$
Global CheckLength$
Global ReplaceSpaceInFileName$


Global S_AND_T_UNMATCHED_FILES&

Global FilesInSource&
Global BiggerFiles&
Global SmallerFiles&
Global EqualFiles&
Global UnequalFiles&
Global NotAFileButFolder&
Global NotAFolderButFile&
Global SkippedSourceFiles&
Global SkippedTargetFiles&

Global MissedFiles&
Global RedundantFiles&



Global FoldersInSource&
Global S_AND_T_UNMATCHED_FOLDERS&
Global MissedFolders&
Global RedundantFolders&
Global EnteredFolders&

Global glCountBites As Boolean
Global BytesCounter&
Global PeriodNote$

Global ExcludeThisExtensions$


Public Sub fcomp_InitStatistics()

S_AND_T_UNMATCHED_FILES = 0
FilesInSource = 0
BiggerFiles = 0
SmallerFiles = 0
EqualFiles = 0
UnequalFiles = 0
NotAFileButFolder = 0
NotAFolderButFile = 0
SkippedSourceFiles = 0
SkippedTargetFiles = 0

MissedFiles = 0
RedundantFiles = 0

S_AND_T_UNMATCHED_FOLDERS = 0
FoldersInSource = 0
MissedFolders = 0
RedundantFolders = 0
EnteredFolders = 0

BytesCounter = 0


End Sub
'DESC this fun is called in two cases:
'     one time for file;
'     another time for folder;
'
'OUTP  for folder:
'          returns false if no target folder;
'                  true if can enter the folder;
'      for file:
'          return value is not used;
'
'NOTE: sometimes before "Exit Function"
'      labels on frmMain are updated
'      to display statistics;
'
Public Function fcomp_FindSourceUnits( _
       FileName$, _
       IsFile As Boolean, Excep$) As Boolean
       
Dim locLocalSourcePath$
Dim SourceName$, TargetName$
Dim TargetLength&, SourceLength&
Dim i&, WB As Boolean, ws$, wi&, wii&
Dim wextension$


fcomp_FindSourceUnits = True
Excep = "" 'non-empty terminates caller of
           'this fun;
           
prof_lblTimeElapsed.Caption = _
   CStr(GetTickCount - prof_StartTime)

On Error GoTo he

locLocalSourcePath = LocalPathInProgress & "\" & _
                     FileName

SourceName = PathedParent & locLocalSourcePath
                  
If "L" = glCompare_Files Then
   TargetName = TargetsPathedParent & _
     "\" & glCompareFiles_Target
Else
   TargetName = TargetsPathedParent & _
                locLocalSourcePath
End If

If Not IsFile Then GoTo CheckFolder
   
'it is proven at the moment that source file exist
SourceLength = FileLen(SourceName)
   
'================================================
' exclude section
'------------------------------------------------
If "L" <> glCompare_Files Then
If DontCountExtension(SourceName) Then
       'this case is handled as files are
       'equal:
       'S_AND_T_UNMATCHED_FILES is unchanged and
       'fcomp_FindSourceUnits = true
       SkippedSourceFiles = _
           SkippedSourceFiles + 1
       BytesCounter = BytesCounter + SourceLength
       GoTo StatisticsToLabels
End If
End If
'================================================
   
'find both files or folders:
If Dir(TargetName, p_AllAttr) = "" Then
   fcomp_FindSourceUnits = False
   MissedFiles = MissedFiles + 1
   S_AND_T_UNMATCHED_FILES = _
    S_AND_T_UNMATCHED_FILES + 1
   mic_fl "  Missed    file      " & _
          locLocalSourcePath
   BytesCounter = BytesCounter + SourceLength
   GoTo StatisticsToLabels
End If

'very good, exists.
'check the name:
'is this target a file?
If (GetAttr(TargetName) And vbDirectory) = _
   vbDirectory Then
   'Target must be a file, but
   'is a folder.
   fcomp_FindSourceUnits = False
   NotAFileButFolder = NotAFileButFolder + 1
   S_AND_T_UNMATCHED_FILES = _
     S_AND_T_UNMATCHED_FILES + 1
   mic_fl "  Must be a file      " & _
      locLocalSourcePath
   BytesCounter = BytesCounter + SourceLength
   GoTo StatisticsToLabels
End If
   
TargetLength = FileLen(TargetName)
prof_lblTotalFileSize.Caption = _
     CStr(SourceLength)
     
If TargetLength <> SourceLength Then
   
   S_AND_T_UNMATCHED_FILES = _
      S_AND_T_UNMATCHED_FILES + 1
   fcomp_FindSourceUnits = False
    
   If TargetLength > SourceLength Then
      ws = "Bigger    file      "
      BiggerFiles = BiggerFiles + 1
   Else
      SmallerFiles = SmallerFiles + 1
      ws = "Smaller   file      "
   End If
   mic_fl "  " & ws & locLocalSourcePath & _
      "  \\source=" & SourceLength & _
      ", target=" & TargetLength
   
   AppendToBatchIfSync SourceName, TargetName, _
        SourceLength, TargetLength, _
        S_AND_T_UNMATCHED_FILES

   BytesCounter = BytesCounter + SourceLength
   GoTo StatisticsToLabels
End If



'lengths are good:
'compare content:

'save time:
If SourceLength = 0 Then
  EqualFiles = EqualFiles + 1
  GoTo StatisticsToLabels
End If


WB = compare_files(SourceName, TargetName, Excep)
If Excep <> "" Then
   fcomp_FindSourceUnits = False
   Exit Function
End If
If Not WB Then
   'sorry, content is different:
   UnequalFiles = UnequalFiles + 1
   S_AND_T_UNMATCHED_FILES = _
       S_AND_T_UNMATCHED_FILES + 1
   mic_fl "  Different file      " & _
     locLocalSourcePath & "  \\"
   fcomp_FindSourceUnits = False
   AppendToBatchIfSync SourceName, TargetName, _
       SourceLength, TargetLength, _
       S_AND_T_UNMATCHED_FILES

   GoTo StatisticsToLabels
End If
EqualFiles = EqualFiles + 1



StatisticsToLabels:
'-----------------------------------------------
' update captions on frmMain labels:
'- - - - - - - - - - - - - - - - - - - - - - - -
  prof_lblCurrentTotalBytes.Caption = _
     CStr(BytesCounter)
  i = GetTickCount - prof_StartTime
  prof_lblTimeElapsed.Caption = _
     CStr(i)
  prof_lblAverageSpeed.Caption = _
     Format(0.001 * BytesCounter / i, "#.000")
'-----------------------------------------------
Exit Function


'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
'processing folder
'===============================================
CheckFolder:
If Dir(TargetName, p_AllAttr) = "" Then
   MissedFolders = MissedFolders + 1
   S_AND_T_UNMATCHED_FOLDERS = _
      S_AND_T_UNMATCHED_FOLDERS + 1
   
   'check is it empty:
   If IsDirEmpty(SourceName) Then
       ws = "  Missed empty folder "
   Else
       ws = "  Missed    folder    "
   End If
   mic_fo ws & locLocalSourcePath
   fcomp_FindSourceUnits = False
   Exit Function

End If
   
   
'very good, unit exists.
If (GetAttr(TargetName) And vbDirectory) <> _
   vbDirectory Then
   NotAFolderButFile = NotAFolderButFile + 1
   mic_fo "  Must be a folder    " & _
      locLocalSourcePath
   fcomp_FindSourceUnits = False
   Exit Function
End If
'good, folder exists
'mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm
Exit Function


he: Excep = "Exception " & Err.Number & " " & _
          Err.Description & ve & _
          "in FindSourceUnits"
    Exit Function


End Function


Public Sub mic_fl(s$)
 pl p2s(S_AND_T_UNMATCHED_FILES) & s
End Sub

Public Sub mic_fo(s$)
 pl p2s(S_AND_T_UNMATCHED_FOLDERS) & s
End Sub





