option explicit


'INPUT:        InitDir - starting folder where to search.
'              ...
'
'OUTPUT:       returns selected file name or "" if cancelled or exceptions;
'DEPENDENCIES: no global variables used;
'
'NOTE:         Specifying FileNameToStart="" may avoids "sticking with specific"
'              file pattern.
'
'
'
Public Function SelectFileToOpen( _
       DialogTitle$, _
       InitDir$, _
       FileNameToStart$, _
       FilterToStart$, _
       Common_Dialog As CommonDialog, Cancelled$)
On Error Resume Next

SelectFileToOpen = ""
Cancelled = ""

With Common_Dialog
        .Filter = FilterToStart
        .DialogTitle = DialogTitle
        .fileName = FileNameToStart
        .InitDir = InitDir
        '-------------------------------
        'prepare to catch an error:
        If Err.Number > 0 Then Err.Clear 'perhaps "overhead": above statements
                                         'may not able to cause an error.
        .CancelError = True
        .ShowOpen
        If Err.Number > 0 Then
        '-------------------------------
           If Err.Number = cdlCancel Then Cancelled = "Y"
        Else
           SelectFileToOpen = .fileName
        End If
End With

Err.Clear  'at any circumstances, clears error for proc-caller.

'final test perhaps is redundant:
'If Dir(SelectFileForOpening) <> "" Then
'   Exit Function
'End If
'SelectFileForOpening = ""

End Function
