Attribute VB_Name = "FileNamesHandler"
Option Explicit

    


Public Function FileBelongsToFolder(WFolder$, WFile$) As Boolean
Dim FNLength%

FileBelongsToFolder = False
FNLength = Len(WFolder)
If FNLength = 0 Then e_app "Folder name is empty."

If UCase(WFolder) = UCase(Left(WFile, FNLength)) Then FileBelongsToFolder = True

    
End Function



Public Function FileNameHasRoot(S$) As Boolean
    
  If InStr(S, ":") > 0 Or _
     InStr(S, "\\") > 0 Then
     FileNameHasRoot = True
  Else
     FileNameHasRoot = False
  End If

End Function



'the same as get_PathedFixedParent, but
'SubmittedEntityName may be added an AppPath
'and may be changed if this is the case;
'
Public Function get_PathedFixedParent$(SubmittedEntityName$, OwnName$)
AttachAppPathTo SubmittedEntityName
get_PathedFixedParent = get_PathedParent$(SubmittedEntityName, OwnName)
End Function

'File name splitter.
'===================
'
'INPUT:  SubmittedEntityName(PRESERVED)      - file name (may full)
'
'OUTPUT: get_PathedParent - path to parent name including parent basic name
'                           (may not with root)
'                           and may be empty;
'        OwnName - the remainder = proper-file-name
'
'NOTES:  if no \ and no : , than parent will be empty;
'        both parent and proper-file-name can happen to be empty;
'        OwnName is prioritezed.
'
'FEATURES: understands :
'
Public Function get_PathedParent$(SubmittedEntityName$, OwnName$)
    Dim path_end%
    path_end = instrrevv(SubmittedEntityName, "\")
    If path_end > 0 Then
       get_PathedParent = Left(SubmittedEntityName, path_end - 1)
       OwnName = Mid(SubmittedEntityName, path_end + 1)
    Else
       path_end = instrrevv(SubmittedEntityName, ":")
       If path_end > 0 Then
          get_PathedParent = Left(SubmittedEntityName, path_end)
          OwnName = Mid(SubmittedEntityName, path_end + 1)
       Else
          get_PathedParent = ""
          OwnName = SubmittedEntityName
       End If
    End If
End Function




Sub AttachAppPathTo(FileName$)
If FileName <> "" Then
   If Not FileNameHasRoot(FileName) Then
     If Left(FileName, 1) = "\" Then
        'fix possible user mistake:
         FileName = App.Path & FileName
     Else
         FileName = App.Path & "\" & FileName
     End If
   End If
End If
End Sub

'DESCR: s - name (full or not)
'OUTPUT: returns File Extention;
'        BasicName;
'
Public Function GetFileExtention(S$, BasicName$)
Dim I&, R$, ws$, OwnName$

R = ""
BasicName = ""

ws = get_PathedParent$(S$, OwnName$)
If OwnName = "" Then GoTo Complete

I = instrrevv(OwnName, ".")
If I = 0 Then
   BasicName = OwnName
Else
   R = Mid(OwnName, I + 1)
   If I > 1 Then BasicName = Left(OwnName, I - 1)
End If

Complete: GetFileExtention = R

End Function

'does the same job as get_PathedParent
'but, no error report;
'
Public Function GetNameWithoutFolder$(S$, FullParentName$)
'    Dim path_end%
'    path_end = instrrevv(s, "\")
'    If path_end > 0 Then
'       FullParentName = Left(full_file_name, path_end - 1)
'       GetNameWithoutFolder = Mid(full_file_name, path_end + 1)
'    Else
'       path_end = instrrevv(s, ":")
'       If path_end > 0 Then
'          FullParentName = Left(full_file_name, path_end)
'          GetNameWithoutFolder = Mid(full_file_name, path_end + 1)
'       Else
 '         GetNameWithoutFolder = s
'          FullParentName = ""
'       End If
 '   End If
End Function

'INPUT:    in_out_FileName          - file name        (may be empty, "\", "\moo...", "...moo\"
'File name fixer and splitter.
'=============================
'
'
'OUTPUT:   in_out_FileName          - proper-file-name (may be empty)
'          EntityPath_FixedAndSplitted         - full-file-name   (never empty)
'          ResultedParentPath       - full-parent-name (never empty )
'
'NOTES:    If no root => then App.path is added.
'
'
Function EntityPath_FixedAndSplitted(in_out_FileName$, ResultedParentPath$)
Dim RetFun$
     
AttachAppPathTo in_out_FileName
RetFun = in_out_FileName
'retfun has : or \\ for sure;
'RetFun is preserved:
ResultedParentPath = get_PathedParent(RetFun, in_out_FileName)
EntityPath_FixedAndSplitted = RetFun
     
End Function






