Attribute VB_Name = "Synchronize"
Option Explicit

Public SynEnabled As Boolean

Public FileSyncLimit&
Public TotalSincSizeLimit&

Public DOS_FC_OptionsString$

Public AbsWork$
Private Const WorkFolder$ = "work"

Public DOS_CumulativeBatch$

Private Const JobDoneMarker$ = "dos_done.txt"
Private AbsJobDoneMarker$
Private Const DOS_BatchFileName$ = "dos_com.bat"
Private DOS_batch_file$

Private Const DOS_Exception$ = "dos_exc.txt"
Private DOS_AbsException$
Private DOS_ExceptionFlag As Boolean

Public NumberOfSynchronized&
Public LengthOfSynchronized&

Public SendTerminationKeys As Boolean
Public EchoDosCommands As Boolean
Private DebugAcrivateWindow$


Public Sub AppendToBatchIfSync( _
           sf$, tf$, sl&, tl&, n&)
Dim ShortFileName$
Dim wi&

wi = sl
If sl < tl Then wi = tl

If MoreToSync Then
   NumberOfSynchronized = NumberOfSynchronized + 1
   LengthOfSynchronized = LengthOfSynchronized + wi
   
   
   ShortFileName = a_IsolateStringByChar( _
        sf, Len(sf), "\")
   If "" = ShortFileName Then Exit Sub
     
   AppendToDOSCumulative "fc " & _
      DOS_FC_OptionsString & _
      " """ & sf & """ """ & _
      tf & """ > """ & _
      n & "_" & ShortFileName & ".txt"
End If

End Sub

Public Sub AppendToDOSCumulative(DOS_Line$)

DOS_CumulativeBatch = _
   DOS_CumulativeBatch & ve & _
   DOS_Line & ve & _
   "if ERRORLEVEL 1 then GOTO EXCEP"

End Sub



Public Sub SynchronizeAndDisplay( _
           DoDOSSynchronization As Boolean, _
           result_file_name$, _
           FileName$)

Dim AbsSource$, AbsTarget$
Dim Dos_Command$
Dim wf#

If Not DoDOSSynchronization Then
   GoTo ReprocessSkipped
End If

'reprocess file for case it "wasn't":
  
'This a globals:
'PathedParent = Dir1.Path
'TargetsPathedParent = dirTarget.Path
  
Select Case glCompare_Files
Case "S"
     AbsSource = glCompareFiles_SourceParent & _
                 "\" & FileName
     AbsTarget = glCompareFiles_TargetParent & _
                 "\" & _
                 glCompareFiles_Target
     result_file_name = _
          "F_i_l_e_" & glCompareFiles_Source & _
          ".txt"
Case "L"
     AbsSource = PathedParent & "\" & FileName
     AbsTarget = TargetsPathedParent & "\" & _
                 glCompareFiles_Target
Case Else
     AbsSource = PathedParent & "\" & FileName
     AbsTarget = TargetsPathedParent & "\" & _
     FileName
End Select
  
wf = FileLen(AbsSource) + FileLen(AbsTarget)
   
Dos_Command = "fc " & DOS_FC_OptionsString & _
      " """ & AbsSource & """ """ & _
      AbsTarget & """ > " & result_file_name
    
    
  'estimate timeout:
  wf = wf / 10000 'per sec
  If wf < 3 Then wf = 2
  If Not ProcessDosCommand(Dos_Command, wf) _
     Then Exit Sub
       
ReprocessSkipped:
  '"loosily" display file:
  aux_DisplayFile AbsWork & "\" & _
        result_file_name, result_file_name, _
        vbNormal, -1, &HFFFFFF, "Locked"
   


End Sub

'DESC  checks current line format:
'      line_start [space(s)]<number>space(s) ...
'                   ... \file_name \\
'
'      then displays file
'      "<number>_short_file_name.txt"
'      or does sync if not set during comparision.
'
'
Public Sub IsolateStringAndDisplay(s$, p&)
 
  Dim StartPos&
  Dim wi&, ws$, file_number&
  Dim IsolatedString$
  Dim FirstSlash&, DoubleSlash&
  Dim NumberInString$
  Dim NumberPosition&
  Dim NumberEnd&
  Dim FileName$
  Dim ShortFileName$
  Dim result_file_name$
  Dim DoDOSSynchronization As Boolean
  
  If Not SynEnabled Then Exit Sub
  
  'convert numeration to string format:
  StartPos = p + 1
  
  IsolatedString = a_IsolateStringByChar( _
        s, StartPos, vl)
  If "" = IsolatedString Then Exit Sub
    
  FirstSlash = InStr(IsolatedString, "\")
  If 0 = FirstSlash Then Exit Sub
  DoubleSlash = InStr(IsolatedString, "\\")
  If 0 = DoubleSlash Then Exit Sub
  wi = DoubleSlash - FirstSlash - 1
  If wi < 1 Then Exit Sub
  FileName = Trim( _
             Mid(IsolatedString, _
             FirstSlash + 1, wi))
  
  ShortFileName = a_IsolateStringByChar( _
        FileName, Len(FileName), "\")
  If "" = ShortFileName Then Exit Sub
  
   
  'pars: ... (1)start_position,
  '          (0)direction,
  '          (1)how many,
  '          (-1)negation
  NumberPosition = getNthOccurencePosition( _
           " ", IsolatedString, _
           1, 0, 1, -1)
  If 0 = NumberPosition Then Exit Sub
  NumberEnd = InStr(NumberPosition, _
                    IsolatedString, " ")
  wi = NumberEnd - NumberPosition
  If wi < 1 Then Exit Sub
  
  NumberInString = Mid(IsolatedString, _
                 NumberPosition, wi)
  
  'try to convert to a number
  On Error Resume Next
  file_number = CLng(NumberInString)
  If Err.Number > 0 Then Exit Sub
  result_file_name = CStr(file_number) & _
         "_" & ShortFileName & ".txt"

  If 0 <> FileSyncLimit Then
     'Skip DOS-Execution-of-Synchronization:
     DoDOSSynchronization = False
  Else
     DoDOSSynchronization = True
  End If
 
  SynchronizeAndDisplay DoDOSSynchronization, _
                        result_file_name, _
                        FileName
   
  
End Sub

Public Function MoreToSync() As Boolean
MoreToSync = False
If SynEnabled Then
   If (NumberOfSynchronized < FileSyncLimit Or _
      FileSyncLimit < 0) And _
      (LengthOfSynchronized < TotalSincSizeLimit _
      Or TotalSincSizeLimit < 0) Then
      MoreToSync = True
   End If
End If
End Function

'EXCE free
'
'DESC processes Dos_Command with output ">"
'     to Dos_ResultFile
'
'RETU false in case of exception;
'     true otherwise;
'
'SIDE EFFECTS
'     in case of problems
'     DOS window may be left open;
'
Public Function ProcessDosCommand( _
                Dos_Command$, _
                TimeOut#) _
                As Boolean

ProcessDosCommand = False
If Not InitDOSCumulative Then Exit Function

AppendToDOSCumulative Dos_Command
       
ProcessDosCommand = ProcessDosCumulative(TimeOut)
     
End Function



Public Function InitDOSCumulative() As Boolean

InitDOSCumulative = False

DOS_ExceptionFlag = False

If Not DirectoryOrMessage(AbsWork) Then _
   Exit Function

DOS_CumulativeBatch = ""
If Not EchoDosCommands Then _
   DOS_CumulativeBatch = "@echo off" & ve
   
DOS_CumulativeBatch = DOS_CumulativeBatch & _
   "cd " & AbsWork & ve & _
   "GOTO BEGIN" & ve & _
   ":EXCEP" & ve & _
   "echo exceptions indicated by ERRORLEVEL > " & _
   DOS_Exception & ve & _
   "echo oo" & ve & _
   "echo EXECPTIONS IN BATCH EXECUTION" & ve & _
   "echo oo" & ve & "GOTO FINISH" & ve & _
   ":BEGIN"


DOS_batch_file = AbsWork & "\" & DOS_BatchFileName
AbsJobDoneMarker = AbsWork & "\" & JobDoneMarker
DOS_AbsException = AbsWork & "\" & DOS_Exception

If Not DeleteOrMessage(DOS_batch_file) Then _
   Exit Function
If Not DeleteOrMessage(AbsJobDoneMarker) _
   Then Exit Function
If Not DeleteOrMessage(DOS_AbsException) _
   Then Exit Function

InitDOSCumulative = True

End Function


'DESC  if vb-exceptions, MsgBox is run and
'      false returned;
'      if ERRORLEVEL exceptions, it may be
'      caught to vb-exceptions;
'
'SIDE EFFECT may happen if Alt+F4 keys option
'            is used resulting in destroying
'            this application
'
Public Function ProcessDosCumulative( _
                TimeOut#) As Boolean
Dim WindowHandler As Variant
Dim TimeOutLimit#
Dim HideOrShowDosWindow&
Dim ws$

ProcessDosCumulative = False
DOS_CumulativeBatch = DOS_CumulativeBatch & ve & _
             ":FINISH " & ve & _
             "echo just a marker > " & _
             JobDoneMarker

ws = write_f(DOS_batch_file, DOS_CumulativeBatch)
If ws <> "" Then
   MsgBox "Batch file creating exception:" _
          & ve & ws
   Exit Function
End If
   
If EchoDosCommands Then
   HideOrShowDosWindow = vbNormalFocus
Else
   HideOrShowDosWindow = vbMinimizedNoFocus
End If
   
On Error Resume Next
'1 - Window has focus and is restored
'to its original size and position:
WindowHandler = Shell(DOS_batch_file, _
                HideOrShowDosWindow)
If Err.Number > 0 Then
   MsgBox "Exception of starting DOS batch:" & ve & _
          DOS_batch_file
   Exit Function
End If
If EchoDosCommands Then AppActivate WindowHandler
On Error Resume Next


'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW
' WAIT LOOP FOR DOS
'================================================
On Error GoTo dos_loop_exception
TimeOutLimit = Timer + TimeOut
Do While Dir(AbsJobDoneMarker) = ""
   DoEvents
   If TimeOutLimit < Timer Then GoTo CannotWait
Loop

On Error Resume Next
'why this exception happens?
Kill AbsJobDoneMarker
'don't kill DOS_batch_file
'to warn user that this name is reserved;
'WWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWW


If "" <> Dir(DOS_AbsException) Then
   'this was never happened and never tested;
   Kill DOS_AbsException
   DOS_ExceptionFlag = True
   MsgBox "Exceptions processing DOS Batch" & _
           ve & "indicated by DOS ERRORLEVEL."
   Exit Function
End If

'DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
' DESTROY DOS WINDOW
'==============================================
If Not SendTerminationKeys Then GoTo TKSkipped
   
On Error Resume Next
AppActivate WindowHandler
If 0 < Err.Number Then
      DebugAcrivateWindow = _
        " second call failed."
Else
      'This statement may destroy
      'this application instead of DOS Window:
      'Send ALT+F4 to close:
      '"True" means, keystrokes must be processed
      'before control is returned to the procedure:
       SendKeys "%{F4}", True
       If Err.Number > 0 Then
          MsgBox "Exception sending termination " & _
             ve & _
             "sequence Alt+F4 to active window."
       Else
          DebugAcrivateWindow = _
             " keys sent succesfully. "
       End If
End If

'display debug results:
'write_f App.Path & "\debug.txt", _
'        DebugAcrivateWindow
'DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

TKSkipped: ProcessDosCumulative = True
Exit Function




'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
' EXCEPTION HANDLERS
'================================================
CannotWait:
    
     MsgBox "TimeOut processing Dos Batch:" & ve & _
            DOS_batch_file & ve & _
            "containinig: " & ve & _
            Left(DOS_CumulativeBatch, 500)
     DOS_ExceptionFlag = True
     Exit Function
     



he:  ws = CStr(Err.Number) & " " & Err.Description
     Resume heh
heh: MsgBox "Exception when processing Dos Batch" _
            & ve & _
            DOS_batch_file & ve & ws
     ProcessDosCumulative = False
     DOS_ExceptionFlag = True
     Exit Function
    



dos_loop_exception:
     ws = CStr(Err.Number) & " " & Err.Description
     Resume heh2

heh2: MsgBox "Exeption when waiting for " & _
            "batch finish. Batch name:" & ve & _
            DOS_batch_file & ve & _
            "when performing statement" & ve & _
            "Dir( " & AbsJobDoneMarker & ")" _
            & ve & ws
            
     ProcessDosCumulative = False
     DOS_ExceptionFlag = True
     Exit Function


'EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
     



'================
' NO SUCCESS:
'WindowHandler = Shell("command.com", 1)
'AppActivate WindowHandler
'SendKeys "exit{ENTER}", True
'SendKeys "cd " & App.Path & "{ENTER}", True

'help_redirected = App.Path & "\fc_help.txt"
'Shell "fc  /?  >  " & help_redirected, vbMinimizedNoFocus '6

 

End Function


Public Sub sync_init()
 AbsWork = App.Path & "\" & WorkFolder
 If Not DirectoryOrMessage(AbsWork) Then
    SynEnabled = False
 End If
End Sub


