Attribute VB_Name = "FileHandlers"
Option Explicit



'EXCE free
'OUTP exceptions and problems submitted
'     via standard variable xR;
'
Public Function fl_check_folder_existence(fn$) _
       As Boolean
 Dim ws$
 
 Const where$ = _
      "Procedure fl_check_folder_existence."
 fl_check_folder_existence = False
 
 On Error Resume Next
 ws = Dir(fn, p_AllAttr)
 If Err.Number > 0 Then
    xR = "Exception " & Err.Number & " " & _
         Err.Description & ve & _
         ve & fn & ve & where
    Exit Function
 End If
         
 If "" = ws Then
    xR = "Directory " & fn & ve & _
         "does not exist." & ve & where
    Exit Function
 End If
 fl_check_folder_existence = True
 
End Function


'EXCE free
'
'DESC if all deleted, returns true
'     if problems, returns false and
'        exception text in xR
'     files which are read-only or have some
'        other conditions preventing them
'        from deletions may stop processing
'        with exeption
'
Public Function fl_delete_all_files_from_folder(fn$) _
       As Boolean
         
  Dim ws$
  
  fl_delete_all_files_from_folder = False

  If Not fl_check_folder_existence(fn) Then _
     Exit Function
     
  On Error Resume Next
  ws = Dir(fn & "\*.*") 'Cannot do
           'this, p_AllAttr) yet because of kill.
  xR = ""

  Do While ws <> ""
     Kill fn & "\" & ws
     If Err.Number > 0 Then
        xR = "Exception " & Err.Number & _
             " " & Err.Description & ve & _
             "when deleting file: " & ve & _
             ws & " in folder: " & ve & _
             fn
        Exit Function
     End If
     ws = Dir
     DoEvents
  Loop
  fl_delete_all_files_from_folder = True
         
End Function


'EXCE not free
'RETU true if directory is empty
'YELD no
'
'
Public Function IsDirEmpty(dn$) As Boolean
  Dim ws$
  IsDirEmpty = True
  
  ws = Dir(dn & "\*.*", p_AllAttr)
  If Err.Number > 0 Then Exit Function
  
  Do While ws <> ""
     If ".." <> ws And "." <> ws Then
        IsDirEmpty = False
        Exit Function
     End If
     ws = Dir
  Loop
  
End Function

Public Function DeleteOrMessage(fn$) As Boolean
Dim ws$

DeleteOrMessage = True

On Error Resume Next

ws = Dir(fn)
If Err.Number > 0 Then GoTo ReportProblems

If ws <> "" Then
   Kill fn
   If Err.Number > 0 Then GoTo ReportProblems
End If

Exit Function

ReportProblems:
   MsgBox "Cannot delete file: " & ve & fn
   DeleteOrMessage = False

End Function



Public Function DirectoryList$(FullFolderPath$, _
       pdir_list, _
       pdir_size, _
       pdir_full_size&, _
       pdir_files_number&, _
       pdir_marked_as_deleted)



'for "DirectoryList" test:
'Private Sub Command1_Click()
'Dim m$, i&, s$, t$
'
'Dim pdir_list       '"file list" of the folder
'Dim pdir_size       'array of "file sizes"
'Dim pdir_full_size& '"the sum of sizes"
'Dim pdir_files_number&
'Dim pdir_marked_deleted
'
's = DirectoryList(POP3MailBoxFullPath, _
'       pdir_list, _
'       pdir_size, _
'       pdir_full_size&, _
'       pdir_files_number&, _
'       pdir_marked_deleted)
'
'
'For i = 1 To UBound(pdir_list)
'    s = s & pdir_list(i) & ve
'    s = s & "to delete: " & pdir_marked_deleted(i)
'    t = t & pdir_size(i) & ve
'Next
'
'MsgBox s
'MsgBox t
'MsgBox "total bytes:" & pdir_full_size & " total_files:" & pdir_files_number
'
'
'End Sub


Dim dir_list$()    '"file list" of the folder
Dim dir_size&()    'array of "file sizes"
Dim dir_full_size& '"the sum of sizes"
Dim dir_files_number&
Dim dir_marked_as_deleted$()

Dim s$, i&, dead_lock&
Const DeadLockLimit& = 1000000

ReDim dir_list(0)
ReDim dir_size(0)
ReDim dir_marked_as_deleted(0)

dir_full_size = 0
dir_files_number = 0

On Error GoTo he

s = Dir(FullFolderPath & "\*.*", p_AllFAttr)
Do While s <> ""
   'instead of DoEvents:
   dead_lock = dead_lock + 1
   If dead_lock > DeadLockLimit Then GoTo he
   dir_files_number = dir_files_number + 1
   ReDim Preserve dir_list(dir_files_number)
   ReDim Preserve dir_size(dir_files_number)
   ReDim Preserve dir_marked_as_deleted(dir_files_number)
   dir_list(dir_files_number) = s
   i = FileLen(FullFolderPath & "\" & s)
   dir_size(dir_files_number) = i
   dir_marked_as_deleted(dir_files_number) = ""
   dir_full_size = dir_full_size + i
   s = Dir
Loop

pdir_list = dir_list
pdir_size = dir_size
pdir_full_size = dir_full_size
pdir_files_number = dir_files_number
pdir_marked_as_deleted = dir_marked_as_deleted

Exit Function

he: xN = Err.Number
    xD = Err.Description
    Resume x
x:  s = CStr(xN) & " " & xD & ve & _
    "Exception in ""DirectoryList."""
    DirectoryList = s
    Exit Function
    
End Function


'EXCE  free
'
'DESC  Restoring directory dn if missed.
'      If df is a file, then it is deleted.
'RETU  false if exceptions
'
'SIDE EFFECTS exception cause msg box to appear.
'
Public Function DirectoryOrMessage(dn$) _
                As Boolean
Dim ws$

DirectoryOrMessage = True
On Error GoTo he
If Dir(dn, vbDirectory) <> "" Then
   If GetAttr(dn) & vbDirectory Then
      Exit Function
   Else
      Kill dn
   End If
Else
   MkDir dn
End If

Exit Function

he:  ws = CStr(Err.Number) & " " & Err.Description
     Resume heh
heh: MsgBox "Cannot (re)create directory:" & ve & _
             dn & ve & ws
     DirectoryOrMessage = False
     Exit Function

End Function

'EXCEPTION: free.
'
'DESCR: Returns exception description if any exception.
'
'
Public Function OpenAndAppendToFileLoosely$(FName$, AText$)
On Error Resume Next
OpenAndAppendToFile FName, AText
If Err.Number > 0 Then
   OpenAndAppendToFileLoosely = Err.Number & " " & Err.Description
End If
End Function


'OUTPUT: returns selected file name or "" if cancelled;
'DEPENDENCIES: no global variables used;
'              depends on EXCEPTION procedures;
Public Function SelectFileForOpening$( _
       FileNameToStart$, _
       FilterToStart$, _
       Common_Dialog As CommonDialog)

SelectFileForOpening = ""
With Common_Dialog
        .Filter = FilterToStart
        If Right(FileNameToStart, 1) = "\" Then
          .FileName = Left(FileNameToStart, _
                      Len(FileNameToStart) - 1)
        Else
          .FileName = FileNameToStart
        End If
        .CancelError = True
        On Error Resume Next
        .ShowOpen
        If Err.Number > 0 Then
           If Err.Number = cdlCancel Then
              Err.Clear
              Exit Function
           Else
              e_raise "exception when selecting a file to open ... "
           End If
        End If
        On Error GoTo he
        SelectFileForOpening = .FileName
End With
Exit Function

he: xD = Err.Description
    xN = Err.Number
    Resume xNext
xNext:
    On Error GoTo 0
    e_up "when selecting file for opening"
        
End Function



'EXCE free
'
'DESCR
'   writes only if file name is not empty;
'   perhaps erases former file if any;
'   creates file if none.
'
'OUTPU    if exceptions, then retursn message;
'         if no exceptions, then returns ""
'
Function write_f$(File_Name$, File_Text$)
Dim handler%, ws$

If File_Name = "" Then Exit Function

handler = FreeFile

On Error GoTo open_error
Open File_Name For Output Access _
     Write Shared As handler
   
On Error GoTo write_error
Print #handler, File_Text;    ' semicolumn is vital here ...
Close #handler

write_f = ""
Exit Function

write_error:
  ws = "Exception " & Err.Number & " " & Err.Description & ve & _
            " when writing a file `" & _
            File_Name & "` in `write_f` module"
  Resume xAfterException
  
open_error:
   ws = "Exception " & Err.Number & " " & Err.Description & ve & _
   "when opening a file `" & _
  File_Name & "` in `write_f` module"
  Resume xAfterException
  
xAfterException: write_f = ws
  Exit Function
  
End Function






Function writeOnlySolidFile$(FileName$, FileText$)
writeOnlySolidFile = ""
If Trim(FileText) = "" Then Exit Function
writeOnlySolidFile = write_f(FileName, FileText)
End Function

'hadles errors using standard VB error handling mechanism
'do not do anything if file name or text_to_append are empty
'
Sub OpenAndAppendToFile(File_Name$, text_to_append$)
Dim handler%
    
If File_Name = "" Then Exit Sub
If text_to_append = "" Then Exit Sub
    
xN = 0
xD = ""

On Error GoTo open_error
handler = FreeFile
Open File_Name For Append Shared As #handler

On Error GoTo writing_error
Print #handler, text_to_append;

On Error GoTo CloseException
Close #handler
Exit Sub '/////////////////////////////////////////////////////////////////////////////////
    

open_error:
    xN = Err.Number
    xD = Err.Description
    Resume xO

xO: On Error GoTo CloseException
    Close #handler
    On Error GoTo 0
    e_up "In OpenAndAppendToFile" & ve & _
    "when opening file: " & File_Name
    
writing_error:
    xN = Err.Number
    xD = Err.Description
    Resume xW

xW: On Error GoTo CloseException
    Close #handler
    On Error GoTo 0
    e_up "In OpenAndAppendToFile" & ve & _
    "when opening file: " & File_Name
         
CloseException:
    If xN <> 0 Then
       xD = CStr(xN) & " " & xD & ve
    End If
    xD = xD & Err.Description
    xN = Err.Number
    Resume xC
    
xC: On Error GoTo 0
    e_up "When closing file: " & File_Name

End Sub


'EXCE free
'
'DESC reads binary file
'     if file does not exist, it is not created;
'
'OUTP returns content of the file
'     if exceptions, returns ""
'
Function read_loosely$(file_to_read$)
Dim handler%, result$, i&

On Error GoTo he
 
If Dir(file_to_read) = "" Then Exit Function
 
handler = FreeFile
Open file_to_read For Binary As #handler
result = Space(LOF(handler))
i = Len(result)
 
If i = 0 Then
   Close #handler
   Exit Function
End If
 
Get #handler, 1, result
Close #handler
read_loosely = result
Exit Function

he:  i = 1
     Exit Function

End Function

